VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CMsgHook"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Event HookMsg(hwnd As Long, uMsg As Long, wParam As Long, lParam As Long, retValue As Long)
Event PreviewMsg(hwnd As Long, uMsg As Long, wParam As Long, lParam As Long, retValue As Long, wndProcAddr As Long)

Sub HookMessages(ByVal hwnd As Long, ParamArray msgList() As Variant)
'
' Call this message to start subclassing
'
' Use values >0 to invoke events AFTER regular processing
' Use values <0 (negated) to invoke events BEFORE regular processing
'
Dim index As Integer
'
' Exit if no events where specified.
'
If LBound(msgList) > UBound(msgList) Then Exit Sub
'
' Build any array holding msg numbers.
'
ReDim msgs(LBound(msgList) To UBound(msgList)) As Long
For index = LBound(msgList) To UBound(msgList)
    msgs(index) = msgList(index)
Next
'
' Start the subclassing.
'
Call HookWindow(Me, hwnd, msgs())
End Sub

Sub AfterMessage(hwnd As Long, uMsg As Long, wParam As Long, lParam As Long, retValue As Long)
    RaiseEvent HookMsg(hwnd, uMsg, wParam, lParam, retValue)
End Sub

Sub BeforeMessage(hwnd As Long, uMsg As Long, wParam As Long, lParam As Long, retValue As Long, wndProcAddr As Long)
    RaiseEvent PreviewMsg(hwnd, uMsg, wParam, lParam, retValue, wndProcAddr)
End Sub

Private Sub Class_Terminate()
' free a slot in MessageHook module
UnhookWindow Me
End Sub












